//============================================================================================//
//    The OpenCV-CamHeadSystem-Project                                                   
//    by                                                                    
//    Rytta Communications Inc.                                           
//    (c) Version 0.207. March 2010                                       
//                     
//    EXPERIMENTAL                                                     
//===========================================================================================// 
//    simBehavior0207.cpp   
//    ---------------------  
//     
//
//    begin     : Thursday 11. March 10.15:00 GMT 2010                            
//    copyright : (C) 2008/2009/2010 by  s.morf                                         
//    email     : stevenmorf@bluewin.ch 

//     compileScript: ./compileScript_87.sh 
//
//     as           : - Main: nomadHeadSystem0207.cpp  
//                    - Sub1: colorTracking0207.cpp
//                    - Sub2: servoTracking0207.cpp 
//                    - Sub3: headSensor0207.cpp
//                    - Sub4: bodyTracking0207.cpp
//                    - Sub5: simBehavior0207.cpp     
//                    - Sub6: audioWriter0207.cpp 
//     
//     run as    : ./nomadHeadSystem0207
//    
//           
/***********************************************************************************************
//  References
//            
//  verwendete programme:
//  from /root/Desktop/OPENCV/opencv-tutorial.pdf (german)
//  <Bildverarbeitung mit OpenCV, author Johannes Wienke, Uni Bielefeld 2008>
//
// OpenCV_Beispiele From RoboWeb
// Mehrere Bilder in einem Fenster
// from http://opencvlibrary.sourceforge.net/DisplayManyImages.

  Display video from webcam
 
  Author  Nash
  License GPL
  Website http:/nashruddin.com
/************************************************************************************************
REFERNECE STARTING WEBCAM:

1) on console
   if you have to reset you cam for any reason, do: 
   1. unplug your cam 
   2. modprobe -r uvcvideo 
   3. modprobe -r snd_usb_audio 
   4. replug your cam  

/************************************************************************************************
NEW NOTES:
25.02. - Entwicklungen (1):
       - ueberlegungen:
         - da fuer den untenstehenden stuff recht tiefgreifenden aenderungen notwendig sind
           - experimental simBehavior0206.cpp
       - (OK) einbau from colorTracking0205.cpp into simBehavior0206.cpp
              - int mimikryRoll() ->  KopfSchuetteln
              - int mimikryNick() ->  KopfNicken
       - SACCADES
         - saccades-functions at trackingX.cpp (Basics) 
           - int ext_Saccades()
         - (OK) eingebaut --> something todos
       - (OK) - KopfSchraebstellen:
                - TurnLeft,  littleRollLeft,  NickDown, centerAllServos
                - TurnRight, littleRollRight, NickDown
              with 
              - headPoseLeft()
              - headPoseRight()
26.02. - OnlineTest 0205
         - besonderes Augenmerk auf verwendung von < c > centerAllServos 
           -  OK
       - 1) - da die beiden functionen schon vorhanden sind
              - ueberlegungen und einbauten von:
                muesste man diese nur richtig aufruften 
                - also  
                  - 1) CenterAllServos <100> with:
                       - ext_SerialServoControl() //  = 100; 
                  - 2) einzelne Servos to Center with:
                       - ext_specialSingleServoCenterControl(int antw)
                         - centerAllServos  = 100;
                         - centerCamServo0  = 101;
                         - centerRollServo1 = 102;
                         - centerNickServo2 = 103;
                         - centerTurnServo3 = 104;   
                         - centerWingServo  = 105;
       - 2) Better and more StateMachine()
            - erkenntnisse:
              - 1) Umbauten:
                   - es besteht im augenblick kein diagram welches die Arbeitsweise von 
                     version 0205 zeigt
              - in colorTracking0205.cpp
                - WICHTIG FOR VERSION 0206 new name as: redBallTracking0206.cpp
                - stateMaschine(); vorhanden wird aber nicht genutzt
                  - der einsprungOrt into SimUp waere  geeignet um Mimikry-Stuff auszuprobieren
                    - mit 2 x random functions (1) Mimikry-stuff (2) bei Saccades einzelne Huepfer  
              - in bodyTracking0205.cpp
                - simUp

NEW VERSION 0206E
03.03. - weitere Entwicklungen (1)
         - 0) ueberlegungen:
              - wegen zunehmender komplexitaet:
                - entwurf nhsDiagramm as text OK (version 0205)
                  - and Visual Ablauf-Diagram version 
                    - new nhsDia4.dia -> visual OK
         - simBehavior0206 into new 0206E
         - 1) simBehavior0206E.cpp 
              - bessere integration von ext_simStateMaschine() 
                - einbau ausserhalb von AutoColorSlider
                  - OnlineVersuch == NOK
                    - sieht recht gut aus, aber eben zu oft, zu schnell und zu brutal
                    - troubles (1) openCv darf den faden nicht verlieren
                      Head- & RedBallTracking kommen nicht zu Zuge
                      - ist jetzt so wie bei einfuehrung von 0205 
         - erkenntnisse: 
           - Mimikry muss ereignis-gerichtet sein
             also if state x the mimikry (N) 
         - 2) - SIM-BEHAVIOR simBehavior0206E.cpp experimental (1) 
                - SACCADES
                  - SACCADES RAUS
         - 3) - MIMIKRY:
                - 1. versuche mit modifizierten mimikryNick()
                     for RedBallDetections
                     - an und ausschalten ueber onRedBall = 1 == ON  onHead = 2 == OFF
                                                onRedBall = 2 == OFF onHead = 1 == ON
                     - 1. erfolge
                          - noch nicht sehr stabil aber
                            System laeuft durch
                - 2. - 1. Versuche mit modifiziert mimikryRoll() ->  KopfSchuetteln
                          for HeadDetections
                          - gleiches System wie bei mimikryNick()
                          - an und ausschalten ueber onHead = 1 == ON  onRedBall = 2 == OFF
                                                     onHead = 2 == OFF onRedBall = 1 == ON
                     - 1. erfolge
                          - noch nicht sehr stabil aber
                            System laeuft durch
               - 1.OnlineVersuche fuers erste zufrieden stellend
04.03. - da in nomadHeadSystem0206 tiefgreifende Aenderungen -> newVersion 0206E
       - da in redBallTracking0206 tiefgreifende Aenderungen -> newVersion 0206E
       - anschliessender OnlineTest: soweit ok 
       - 1) WeiterEntwicklungen (1)
            - Ueberlegungen ob with key < q > Restart aller Anwendungen moeglich ist
              - also CenterAllServos
              - a) Restart starting simBehavior
              - b) RedBallDetections
              - c) HeadDetections
            - eingebaut
       - 1.OnlineTest with < q > as Restart
           - soweit OK stabilitaet ??
           - aber das system faengt sich
           - koennte spaeter als healing (Heilend) benutzt werden
       - 2.For RedBall-Detections Anwendungsbeispiele suchen
           - 1) bei redBallTrack -> system muss jetzt naeher am Zentrum sein
                um sagen zu konnen box.x == camx 
           - 2) versuch starten Lines zwischen Box und cam als ServoStep zu verwenden
                - new vars as:
                  xLineStep, yLineStep;
       - Diese Versuche NOK
         - Back to the ROOTS
           - weiterer Versuch steps (Turn/Nick) auf 20 erhoehen
       - sieht recht gut aus -> better
       - 3. Ueberlegungen (1) zu:
            - BallPlaying (1) 
              - Ueberlegungen(1)
                - new redBallStateMachine()
                  with:
                  read PING-Sensor
                  range_cm = range_mm / 10;
                - 1. ergebnisse: verry small ca. 10.nnnn cm OK
                     was in behavior 
                - 2. Ermittelte unterschiedliche EntfernungsWerte:
                     - PING Range_cm: 12.600000
                     - PING Range_cm: 17.300000
                     - PING Range_cm: 25.300000
                     - PING Range_cm: 30.200000
                     - PING Range_cm: 37.500000
                     - PING Range_cm: 43.100000
                     - PING Range_cm: 325.400000
                 - 3. 1. versuche mit untenstehenden abfragen ss. redBallTracking0206E
      
                  if (range_cm verry small) then Angry
                  if (range_cm small)       then Fear
                  if (range_cm middle)      then Playing     

               - Posing (left/right)
               - Fear, Angry with PING
               - faster RedBallTracking  Turn- NickStep on 20 its better
               - UnBedingt Direkte Winglets beeinflussung 
05.03. - WeiterEntwicklungen
       - OnlineTests (1) 
        - 1) Vereinfachung von Behavior ( NO 2 x unterschiedliche Behavior-Functions)
            - erkenntnisse:
              - 1. behavior-function == in simBehavior0206E
                   -> simUP = it's control here
                      if(simCnt == 0 ) then -> ext_simBehavior();
                      (startStage)
              - 2. behavior-function in redBallTracking0206E
                 - normal Stage
            - Umbauten
              - Behavior from redBallTracking0206E to simBehavion0206E
       - compile & run OK
       - 2) versuche mit untenstehenden abfragen ss. redBallTracking0206E
            - 1) ANGRY -> from simBehavior0206E
                 - mimikryAngryNick();
                   - if (range_cm small)       then ANGRY
                     -> ANGRY -> SMALL
                        if((range_cm > 40.1) && (range_cm < 200.0))
                        -> mimikryAngryNick();
                 - compile and run soweit OK
                   - with DEBUG exit(0) -> EINSPRUNG OK -> ANGRY
       - 3) nach etlichen FehlVersuchen
            1) ServoAbstuerze wegen falschen Werte
            2) folgendes funktioniert
               1) - FEAR -> VERRY SMALL  
                    - if(range_cm < 10.0) 
                         then -> mimikryFearPoseLeft();
               2) - ANGRY -> SMALL
                    - if((range_cm > 10.0) && (range_cm < 15.0))
                          then -> mimikryAngryNick();
               3)  NOTHING TODOs
                   - if(range_cm > 15.1)
                     then -> printf("\nOUTSIDE\n");
            3) ERKENNTNISSE:
               - PingWerte muessen sehr klein sein
                 - sonst faellt das System von einem Extrem ins Andere   
               - Bei solchen Sachen muss der Ablauf stimmen
                 - sonst verliert OpenCV den Faden und bleibt stehen
       - 4) Die Grenze der Zusatz ServoMovements 
            ist jetzt vermutlich erreicht
            - da es sonst zu Timming-Problemen kommt
              - denk auch an den Sound  
06.03. - weitere Entwicklungen 
         - OnlineTests (1) basic:
       - 1) Posing Right as : BUUHA  
            - as:
              - int mimikryBuuhaPoseRight()       
       - 2) - Unbedingt Stabilitaet verbessern   
              - 1. langzeit test recht gut
                   - erkenntnisse:
                     - reagiert auch auf redLedLight -> redBall 
              - 2. langzeittest with Mimikrys OK
       - 3) - Ueberlegungen:
              - wegen zunehmender komplexitaet:
                 - and Visual Ablauf-Diagram version 
                 - new DIAGRAM4.dia -> visual OK
       - 4) ueberlegungen:
            - um ueberhaupt Behavior beeinflussen zu koennen muesste man zuerst wissen
              wo ueberhaupt behavior ist.
            - moeglichkeiten bei cvSimBehavior4.cpp
              yellow Point
            - einbau into simBehavior0206E into Behavior
              - yellowPoint on RightWindow
                - auch wenn yellow Point noch nicht Behavior representiert
                  - sieht es so aus als wuerde Behavior viel zu wenig angesprungen 
            - compile ok
            - run no servos ok
            - with servos OK
          - moeglichkeiten yellowPoint and good behavior
             gem. simUP from cvSimBehavior4.cpp
      - 5) new simBehavior0206E1.cpp
            - for new Behavior()
              - into main: stuff for Behavior
                - weight0 = 10.0;     
                  X0      = 240.0;  // = StartWert1 Y-dir
                  Xf0     = 10.0;   // EndPosY      Y
            - umbauten Behavior(); ex. simUp
              -
            - fuer Regelungen ss. simBehavior4.cpp
              -> stateMachine
              -> into E1 -> simStateMachine() ANPASSUNGEN
                 -> gemacht -> testen
       - compile E1 OK   
07.03. - 1.OnlineTests mit new simBehavior0206E1.cpp
         - no servoMovements (1)
           - allg.Verhalten OK
           - Behavior -> yellowPoint
             - da noch nicht angepasst
               - yellow Point steigt extrem schnell an und bleibt dann oben
         - no servoMovements (2)
           - allg.Verhalten 
           - Behavior -> yellowPoint
           - point movements ok 
           - Behavior have negative values: 
             -> Behavior
                Behavior: -0.041667
             -> winglets negative 
                WingServo: 51273  -> this are negative da Neutral base == 51_300
       - fehlerSuche OK
         - double normal was 0.0; statt 240.0;   
           with:
             weight0 = 10.0;     
             X0      = 240.0;  // = StartWert1 Y-dir
             Xf0     = 10.0;   // EndPosY      Y
       - 2.OnlineTest with Servos and new Version 0206E1
         - OK
       - in main extern Behavior() testen 
         - es erscheinen manchmal 2x verschobene points 
         - also if stateMachine OK nur 1x in main while aufrufen
       - da in simBehavior0206E1 (here)
         - bereits eine function stateMachine vorhanden ist
           - fuer allgmeinen gebrauch  look at stateMachine0206E1.txt
       - einbau von stateMachine(); 
         - compile OK
       - 1.OnlineTests no servo only looking behavior
           - erkenntnisse:
             - yellowPoint moving i.A. nicht so wie er sollte -> schnellere Up/Down Bewegungen
               - with center point moving down == NOK
                 - behavior == 0.0
               - with Q bad stuff
               - ev. muesste function oeffters aufgerufen werden
                 - in main : while massive erhoehung der aufrufe
                   - koennte auch an den vielen printfs liegen
                 - dadurch aber sehr stockende BildVerarbeitung ????
       - 1.OnlineTest with Servos    
           - erkenntnisse:
             - eindeutig zu viele aufrufe von behavior
               - opencv bleibt stehen
             - umbauten ueberall Behavior() raus jetzt nur noch 3x
               - plus jalousien runter wegen opencv
                 - jetzt schon besser
             - fehler (1): 
                - no good SimBehavior too fast no Anzeige
                  - erhoehung von weight0 auf 50.0 dann besser
                - wenn man dem system zeit laesst passieren manchmal gute verhaltensweisen
                  - z.B. wenn das system mit roten Leds angestrahlt wird
                    - koennte man sagen == es hat das nicht so gerne
                      - dreht sich weg
             - Behavior()       
               - wird langsam besser
                 - den gelbenPunkt sollte man baldmoeglichst raus nehmen 
                   - verlangsamung ev. auch durch yellowPoint
             - fehler (2):
               - < Q > ist sehr gefaehrlich voellig indifferentes verhalten
                 - auch absturz Opencv moeglich bleibt dann stehen
               - tests mit < Q >
                 - hat noch einige fallstricke
               - fehlerbehebungen
                 - richtige X0,Xf0,weight0
                 - < Q > == true raus
                 - Behavior() rein
             - macht jetzt das was er soll
08.03. - weiter-entwicklungen:
         - 1.onlineTest
             - ohne servos: OK
             - mit servos:  soweit ok
               - ev. troubles with < Q >
                 - or ev. window jalousie runter

       - versuche mit neuralNet0206E1.txt
         - ergebnisse:  
           - einbauten into 0206E1
       - compile OK
       - Run ohne Servos -> sehr vielversprechend:
         - vergleich von 
           - BEHAVIOR (2): 0.687505
             - mit
           - NeuralNet
             - Hidden Input 1 =  0.143241
             - Hidden Input 2 = 0.152203
             - Hidden output 1 = 0.535749
             - Hidden output 2 = 0.537977
             - Output in_3 = 0.644459
             - Final Output = 0.655761
             - NN_Behavior: 0.655761
             finished
         - sehr gutes ergebniss.
         - da noch 2 wights vorhanden sind
           - double W_31 = 0.7;
           - double W_32 = 0.5;
         - koennte man diese interaktiv veraendern
           - wenn values verzehntfacht werden also auf 7.0 + 5.0 then nnBehavior  0.998413
         - moeglichkeit der interaktiven veraenderung fuer W_31, W_32 suchen:
         - 1.versuch einbau into
             - redBallTracking0206E.cpp
               - in redBallStateMachine() -> ANGRY FEAR
                 - Ref:
                   extern double W_31;
                   extern double W_32; 
                   double max_range_cm = 325.0;
                   double min_range_cm =   5.0;
                   double w_p       - else range_cm > 13.0)
                     -> printf("OUTSIDE\n");
                        W_31 = 0.7 + ((max_range_cm - range_cm) * w_pingFac); 
                        W_32 = 0.5 + ((W_32 + W_31) / 2.0); 
              - wenn in outside obige werte verwendet werdeningFac = 0.0028985;
                 - in redBallStateMachine()
                   - W_31 = (max_range_cm - range_cm) * w_pingFac; 
                   - W_32 = (W_32 + W_31) / 2.0;
                   - else range_cm > 13.0)
                     -> printf("OUTSIDE\n");
                        W_31 = 0.7 + ((max_range_cm - range_cm) * w_pingFac); 
                        W_32 = 0.5 + ((W_32 + W_31) / 2.0); 
                  - else range_cm > 13.0)
                     -> printf("OUTSIDE\n");
                        W_31 = 0.7 + ((max_range_cm - range_cm) * w_pingFac); 
                        W_32 = 0.5 + ((W_32 + W_31) / 2.0); 
              - wenn in outside obige werte verwendet werden
                - then leicht hoehere nnBehavior-Values. 0.6 to 0.8
         - 1.OnlineTests ohne/mit Servos OK
         - jetzt ueberlegen ob nnBehavior fuer Winglets benutzbar ist          
09.03. - einsatz von nnBehavior
         - ev. changing W_31, W_32
             
       - 1. ueberlegungen zu punkt 1):
            - verwendung eines neuralenNetzes: look at neuralNet0206E1.txt
              - moeglichkeiten
                - 1) in simUp ist bereits ein kleines Netz vorhanden
                - 2) gleicht BehaviorNet1.c
                - 3) nn_5.c = ausgefeilter aber grosse umbauten notwendig
                     - handelt von Spinnentier-Legs 
                       - laeuft deswegen solange error == 0.0
                     - wir wollen ja eigentlich nur eine dynamische anpassung von werten
              - inputs:
                - States -> verschiedene states ergeben verschiedene inputWerte
                - vorhandenen Behavior-Wert
                - Ping range_mm or range_cm je kleiner desto groesser
                - BIAS-Wert ??? -> error
              - output:
                - netBehavior
            - look at neuralNet0206E1.txt  

  
                 
TODOS: - 1) - DYNAMICAL AUTONOME BEHAVIOR make it better
              - 1) Better Winglets Movements
              - 2) Better Behavior
                   - moeglichkeiten
                     - ev. with NeuralNets         
                     - ev. mit globalen Zaehlern
                       - if stateX == true  -> x-- (abnehmende Interesse)
                       - if stateX == false -> x++ (zunehmende Interesse)
                     - mit prioritaeten 
              - 3) Better Automatical CenterAllServos
              - 4) < q > Better Restart ev. automatical     
                   - Ueberlegungen: Restart with key < Q > as automatical Healing (heilend)  


-------------------------------------------------------------------------------------------------

Servo-References: dd. 12.02.2010
- cvWebCamGluiControl14.cpp  
  Alle Korrekte ServoValues for Doku: Min/Max
  - CamServo0: 
    - Center: 1_500   -> 11_500  InitCenter OK 
    - Left  : 1_250   -> 11_250             OK
    - Right : 1_750   -> 11_750             OK
                    
  - RollServo1: ( mit neu umgekehrten (+/-) )
    - Center: 1_660  -> 21_660 OK initCenter OK       
    - Left  : 1_700  -> 21_700 OK old 1_620    
    - Right : 1_620  -> 21_620 OK old 1_700 
          
      (*) fraglich ob eines Rollen ueberhaupt Sinn macht

  - NickServo2: 
    - Center: 1_400            -> 31_400 InitCenter OK
    - UP    : 1_600  old 1_100 -> 31_600            OK 
    - Down  : 1_300  old 1_600 -> 31_600            OK 
     
  - TurnServo3: 
    - Center: 1_400              41_400    InitCenter OK,  
    - Left  : 1_000  ca  45 deg  41_000 OK 
    - Right : 1_800  ca. 45 deg  41_800 OK 
              
  - WingLetsServo               
    - Center                          : 1_300 -> 51_300 OK
    - WingLets Anheben UP   max.Right : 1_950 -> 51_950 OK  max.Right 2_000  
    - WingLets Senken  DOWN min.Left  : 1_300 -> 51_300 OK  min.Left  1_000

-------------------------------------------------------------------------------------------------
Ref: - koppelung von Behavior to WingletsTurn
NEW STUFF dd. 07.02.2010

   wingBase   = 51300;
   wingCenter =  1300
   wingUp     =  1950  // max 2000  old: 750
   wingDown   =  1300
   stepwidth: =   650
   wingFactor = 650 / 100 = 6.5;
   wingStep   = (Behavior * wingFactor) * 100.0 (0.998 = 648)
   wingServo:
   wingServoUp   = wingBase + wingStep;   
   wingServoDown = wingServoUp - wingStep 

double wingBase = 51300.0;
double wingFactor = 6.5;
double wingStep;
double wingServoUp;
double wingServoDown;
int wingServoCenter = 51300;
  
/**************************************************************************************************/
#include <iostream>

#include "cv.h"
#include "highgui.h"

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <math.h>
#include <float.h>
#include <limits.h>
#include <time.h>
#include <ctype.h>

#include <X11/Xlib.h>
#include <X11/extensions/XTest.h>

using namespace std;
/**************************************************************************************************/
#define WIDTH  640
#define HEIGHT 480

#define SEARCHRANGE 100

#define STATE_UP   0
#define STATE_DOWN 1

#define CHANGE_NONE 0
#define CHANGE_SHRINKING 1
#define CHANGE_GROWING 2

#define CHANGEFACTOR .75

int rgbCENTERX = 320;
int rgbCENTERY = 240;

int rgbCAMX = rgbCENTERX;
int rgbCAMY = rgbCENTERY;

int SEARCHX = -1;
int SEARCHY = -1;

int STARTW = 100;
int STARTH = 100;

int LASTH = 100;
int LASTW = 100;

int SHAPECHANGE = CHANGE_NONE;

CvPoint TOPLEFT;
CvPoint BOTTOMRIGHT;

int TRACKCLICK = 0;
//int blueBodyClick = 0;
int STATE;   // notwendig for tracking Algo


int rc = NULL, gc = NULL, bc = NULL;

CvRect rgbBox;

// Calculations Behavior:
extern double behavior;
extern double factor;  // 0.0041667;  // 1.0 / 240
double normal = 240.0;
extern int step;       // = 0;

bool rgbOBENLINKS;
bool rgbOBENRECHTS;
bool rgbUNTENRECHTS;
bool rgbUNTENLINKS;

int onHead;
int onRedBall;

int randNos;
int sacCnt;

int ii = 0;
extern int intX0;

// neuralNet
extern int range_mm; // SensorInput -> pingHeadSensor        
int max_range_mm = 3200;
int min_range_mm = 50;

double inBehavior;  // normal Behavior
double nnBehavior;
double inStates;    // weight0
 
double pingFac = 0.0003125;   //  - pingFac // 1.0 / 3200 == 0.0003125
double inPing;  

// nn_1.c
double in_1;
double in_2;
double W_11; // = 0.1;
double W_12; //  = 0.5;
double W_21; // = 0.9;
double W_22; // = 0.8;
double W_31; // = 0.7; now in redBallTracking0206E.cpp in redBallStateMachine
double W_32; // = 0.5;

double Hid_in_1;
double Hid_in_2;
double Hid_out_1;
double Hid_out_2;

double Out_in_3;
double out_final;   

/**************************************************************************************************/
// extern Vars.

// from RedTrack
extern Display *dpy; // = XOpenDisplay (0); 
extern IplImage *frame1;
extern IplImage *frame2;
extern IplImage *temp1;

extern CvFont font;

extern const char *texte4;

extern bool CENTER_SERVOS_100_KEYc;
extern bool SERIAL_SENDDATAS_KEYs;
extern bool WANT_SENSOR_DATAS_KEYr;
extern bool AUTO_COLORSLIDE_KEYa;
extern bool STOP_COLORSLIDE_KEYq;
extern bool RED_BALL_TRACK;
extern bool HEAD_TRACK;
extern bool BACK_GROUND_TRACK;
extern bool WINDOW_TRACK;
extern bool initHeadTrack; 

extern int CamServo0;   // = 11500;  
extern int RollServo1;  // = 21660;  new Head guckt geradeaus  old: 21_660 
extern int NickServo2;  // = 31340;  new Head guckt geradeaus mit Schale  Kinn on whiteBlock old: 31400;  
extern int TurnServo3;  // = 41400; 
extern int WingServo;   // = 51300;
 
extern int centerAllServos;
extern int centerCamServo0;
extern int centerRollServo1;
extern int centerNickServo2;
extern int centerTurnServo3;   
extern int centerWingServo;

extern int newCamServo;
extern int newRollServo;
extern int newNickServo;
extern int newTurnServo;
extern int newWingServo;

extern int wingServo;
extern int camStep;
extern int nickStep;
extern int turnStep;
extern int rollStep;
extern int turnStep;
extern int camClick;
extern int rollClick;
extern int nickClick;
extern int turnClick;

extern int antw;  // = 0;

extern int onWindow;
extern int onBackGround;


extern bool onStartA;
extern bool onStopA;
extern bool onStartBG;
extern bool onQ;

// BehaviorLine yellow
extern double X0;         // = StartWert1
extern int intX0;         // = for Slider 
extern double Xf0;        // EndPosY 
extern int intXf0;        // endPoint slider
extern double weight0;    // gewichtungen 
extern int intWeight0;
                    
// winglets
extern double wingBase;       // = 51300.0;
double wingFactor = 6.5;
extern double wingStep;
extern double wingServoUp;
extern double wingServoDown;
extern int wingServoCenter;   // = 51_300

extern int simCnt;

extern int centerCamServo0; //  = 101;


/**************************************************************************************************/
// externe functionen
int ext_servoTrackControl();
int ext_SerialServoControl();
void Behavior();
/**************************************************************************************************/
template<class T> class Image 
  {
     private:
     IplImage *imgp;

     public:
     Image (IplImage *img=0) {imgp = img;}
     ~Image () {imgp = 0;}
     void operator=(IplImage *img) {imgp=img;}
     inline T* operator[] (const int rowIndex) 
        {
           return ((T*)(imgp->imageData + rowIndex*imgp->widthStep));
        }
  };
/**************************************************************************************************/
typedef struct 
   {
      unsigned char b,g,r;
   } RgbPixel;

typedef struct 
  {
     float b,g,r;
  } RgbPixelFloat;

typedef Image<RgbPixel> RgbImage;

/**************************************************************************************************/
void setRGB_NULL()
  {
     rc = NULL;
     gc = NULL;
     bc = NULL;
  }
/************************************************************************************************/
// mimikry Roll 
int mimikryRoll()
  {
     if(onHead == 1)
        {
           rollClick = 40;
           // new RollServo Left
           newRollServo = RollServo1 - rollClick;
           antw = newRollServo;
                  
           ext_servoTrackControl();
           RollServo1 = newRollServo;
                                
           // RollServo = Back to Neutral
           newRollServo = RollServo1 + rollClick;
           antw = newRollServo;
                  
           ext_servoTrackControl();
           RollServo1 = newRollServo;
           
           onHead = 2;
           onRedBall = 1;
        
           printf("MimikryRoll\n");
        }
  }
/************************************************************************************************/
// mimikry Nick -> Yes
int mimikryNick()
  {
     // new stuff 03.03.2010
     if(onRedBall == 1)
        {
           nickClick = 100; 
           // new NickServo UP
           newNickServo = NickServo2 - nickClick;
           antw = newNickServo;
                  
           ext_servoTrackControl();
           NickServo2 = newNickServo;
                                
           // NickServo = Back to Neutral
           newNickServo = NickServo2 + nickClick;
           antw = newNickServo;
                  
           ext_servoTrackControl();
           NickServo2 = newNickServo;
           
           onHead = 1;
           onRedBall = 2;
    
           printf("MimikryNick\n");
        }
  }
/************************************************************************************************/
int mimikryAngryNick()
  {
     printf("MimikryAngryNick\n");
     
     if(newNickServo < 31500)
        {
           nickClick = 200; 
        }
     if(newNickServo > 31500)
        {
           nickClick = 50;
        }  
         
     // new NickServo UP
     newNickServo = NickServo2 - nickClick;
     antw = newNickServo;
                  
     ext_servoTrackControl();
     NickServo2 = newNickServo;
                                
     // NickServo = Back to Neutral
     newNickServo = NickServo2 + nickClick;
     antw = newNickServo;
      
     ext_servoTrackControl();
     NickServo2 = newNickServo;
           
     // winglets Angry
     wingStep    = 650;   // behavior * factor;
     wingServoUp = wingBase + wingStep;
     wingServo = (int)wingServoUp; 
        
     // new StandAllone Behavior
     // um immer Behavior anzuspringen
     // um unnoetige ServoTracks zu vermeiden
     if(wingServo > 51301)
        {  
           antw = wingServo;
           printf("WingletServoAntw: %d\n",antw);
           // uebergabe an ServoTracking with
           
           ext_servoTrackControl();
        }
     
     // new Raus
     // wingStep = behavior * factor;
  }
/************************************************************************************************/
// FEAR
int mimikryFearPoseLeft()
  {
     // turnLeft = 41_250   OK
     // rollLeft = 21_770   max
     // nickDown = 31_360
     // winglets = 51_950
     // centerAllServos 

     printf("MimikryFearPoseLeft\n");

     // turnLeft = 41_250
     // TurnServo3
     turnClick = 400;
     newTurnServo = TurnServo3 - turnClick;
     
     antw = newTurnServo;
     ext_servoTrackControl();
     TurnServo3 = newTurnServo;
     
     // rollLeft = -> 21_700  OK   neutral 1_660
     // rollServo1
     rollClick = 40;
     newRollServo = RollServo1 + rollClick;
     
     antw = newRollServo;
     ext_servoTrackControl();
     RollServo1 = newRollServo;

     // nickDown = 31_360 - Down  : 1_300  -> 31_300 OK      
     // NickServo2
     nickClick = 100;
     newNickServo = NickServo2 + nickClick;
      
     antw = newNickServo;
     ext_servoTrackControl();
     NickServo2 = newNickServo;
                                
     // winglets Angry
     wingStep    = 650;   // behavior * factor;
     wingServoUp = wingBase + wingStep;
     wingServo = (int)wingServoUp; 
     
     // new StandAllone Behavior
     // um immer Behavior anzuspringen
     // um unnoetige ServoTracks zu vermeiden
     if(wingServo > 51301)
        {  
           antw = wingServo;
           printf("WingletServoAntw: %d\n",antw);
           // uebergabe an ServoTracking with
           
           ext_servoTrackControl();
        }

     // CenterAllServos
     ext_SerialServoControl();
     
     // new raus
     // wingStep = behavior * factor;
  }  
/*************************************************************************************************/
// BUUHA
int mimikryBuuhaPoseRight()
  {
     // turnRight = 41_800  400 OK
     // rollRight = 21_620   max
     // nickDown = 31_360
     // winglets = 51_950
     // centerAllServos 

     printf("MimikryBuuhaPoseRight\n");

     // turnRight = 41_800 center 41_400
     // TurnServo3
     turnClick = 400;
     newTurnServo = TurnServo3 + turnClick;
     
     antw = newTurnServo;
     ext_servoTrackControl();
     TurnServo3 = newTurnServo;
     
     // rollRight = -> 21_620  OK   neutral 1_660
     // rollServo1
     rollClick = 40;
     newRollServo = RollServo1 - rollClick;
     
     antw = newRollServo;
     ext_servoTrackControl();
     RollServo1 = newRollServo;

     // nickDown = 31_360 - Down  : 1_300  -> 31_300 OK      
     // NickServo2
     nickClick = 100;
     newNickServo = NickServo2 + nickClick;
      
     antw = newNickServo;
     ext_servoTrackControl();
     NickServo2 = newNickServo;
                                
     // winglets Angry
     wingStep    = 650;   // behavior * factor;
     wingServoUp = wingBase + wingStep;
     wingServo = (int)wingServoUp; 
     
     // new StandAllone Behavior
     // um immer Behavior anzuspringen
     // um unnoetige ServoTracks zu vermeiden
     if(wingServo > 51301)
        {  
           antw = wingServo;
           printf("WingletServoAntw: %d\n",antw);
 
           // uebergabe an ServoTracking with
           ext_servoTrackControl();
        }

     // CenterAllServos
     ext_SerialServoControl();
     
     // new raus
     //wingStep = behavior * factor;
  }
/*************************************************************************************************/
int headPoseLeft()
  {
     // TurnServo Left 22.5°
     turnStep = 200;
     newTurnServo = TurnServo3 + turnStep;
           
     antw = newTurnServo;
     ext_servoTrackControl();
           
     // NickServoDown
     nickStep = 100;
     newNickServo = NickServo2 - nickStep;
            
     antw = newNickServo;
     ext_servoTrackControl();
                 
     // RollServoLeft
     rollStep = 40;
     newRollServo = RollServo1 - rollStep;
                  
     antw = newRollServo;
     ext_servoTrackControl(); 
                     
     // CenterAllServos 100
     ext_SerialServoControl(); 
  } 
/*************************************************************************************************/
int headPoseRight()
  {
     // TurnServo Right 22.5°
     turnStep = 200;
     newTurnServo = TurnServo3 - turnStep;
           
     antw = newTurnServo;
     ext_servoTrackControl();
           
     // NickServoDown
     nickStep = 100;
     newNickServo = NickServo2 - nickStep;
            
     antw = newNickServo;
     ext_servoTrackControl();
                 
     // RollServoRight
     rollStep = 40;
     newRollServo = RollServo1 + rollStep;
                  
     antw = newRollServo;
     ext_servoTrackControl(); 
                     
     // CenterAllServos 100
     ext_SerialServoControl();                
  }   

/*************************************************************************************************/
int rgbTrackServo()   
  {
     printf("RGB-TrackServo-Functions\n");
       
     // testen of left or right
     if((rgbOBENLINKS == true) || (rgbUNTENLINKS == true))
        { 
              // CAMSERVO
              camStep = 125;  
              newCamServo = CamServo0 - camStep;
                            
              antw = newCamServo;   
              ext_servoTrackControl();

              printf("RGB-Links\n");                  
                    
              if((rgbBox.x > 300 ) && (rgbBox.x < 340))  
                 {
                    printf("BoxTrack_X Done\n");
                    
                    goto endFunc; 
                 }   
        } // end links
 
     if((rgbOBENRECHTS == true) || (rgbUNTENRECHTS == true))
        {           
           // CAMSERVO
           camStep = 125;
           newCamServo = CamServo0 + camStep;
                       
           antw = newCamServo;   
           ext_servoTrackControl();  
                 
           printf("Rechts\n");
                     
           if((rgbBox.x > 300 ) && (rgbBox.x < 340))  
              {
                 printf("BoxTrack_X Done\n");
                 
                 goto endFunc; 
              }  
        }   
          
     // new stuff
     endFunc:;  

     // einstieg von Winglets-ServoMovements
     // um unnoetige ServoTracks zu vermeiden
     // AUSDOKUMENTIERT da diese version nur angesprungen wird
     // wenn red-ball-track = true
            
     if(wingServo > 51301)
        {  
           antw = wingServo;
           printf("WingletServoAntw: %d\n",antw);
           // uebergabe an ServoTracking with
           
           ext_servoTrackControl();
        }
  }     
                 
/**************************************************************************************************/
// new trackCalc dd. 21.02.2010
// new Function as:
void rgbTrackCalc()
  { 
     printf("TrackCalc\n");
     
     printf("Box.x: %d, Box.y: %d\n",rgbBox.x,rgbBox.y);
     printf("CamX: %d, CamY: %d\n",rgbCAMX,rgbCAMY);   
     
     // (1) obenLinks:   
     if((rgbBox.x < rgbCAMX) && (rgbBox.y < rgbCAMY))
        {
           rgbOBENLINKS = true;
           
           printf("RedBox: ObenLinks\n");
        }     
     
     // (2) obenrechts
     if((rgbBox.x > rgbCAMX) && (rgbBox.y < rgbCAMY))
        {
           rgbOBENRECHTS = true;
           
           printf("RedBox: ObenRechts\n");
        }
     
     // (3) untenRechts:
     if((rgbBox.x > rgbCAMX) && (rgbBox.y > rgbCAMY))
        {
           rgbUNTENRECHTS = true;
           
           printf("RedBox: UntenRechts\n");
        }
     
     // (4) untenLinks : 
     if((rgbBox.x < rgbCAMX) && (rgbBox.y > rgbCAMY))
        {
           rgbUNTENLINKS = true;
           
           printf("RedBox: UntenLinks\n");
        }
   
     printf("Now RGB-ServoTracking\n");   
     rgbTrackServo();

     rgbOBENLINKS   = false;
     rgbOBENRECHTS  = false;
     rgbUNTENRECHTS = false;
     rgbUNTENLINKS  = false;
 
     // boolTarget  = false;   
  } 
/**************************************************************************************************/
void simStateMachine()
  {
     printf("\n\n SimStateMachine\n");

     if(( X0 < 182.0 ) && (X0 > 178.0 ))  // (26.0 24.0) 25 % = new 240 - 60 == 180
        {
           WINDOW_TRACK = true;
           BACK_GROUND_TRACK = false;
           HEAD_TRACK = false;
           RED_BALL_TRACK = false;

           printf("Into WindowTrack with X0: %f\n",X0);
        }
      
     if(( X0 > 118.0 ) && (X0 < 122.0 )) // (48.0 52.0) 50 % = 240 - 120 == 120
        {   
           WINDOW_TRACK = false;
           BACK_GROUND_TRACK = true;  
           HEAD_TRACK = false;
           RED_BALL_TRACK = false; 

           printf("Into BackGroundTrack with X0: %f\n",X0);
        }

     if(( X0 > 58.0 ) && (X0 < 62.0 )) // (74.0 76.0) 75 % = 240 - 180 == 60 
        {
           WINDOW_TRACK = false;
           BACK_GROUND_TRACK = false;  
           HEAD_TRACK = true;
           RED_BALL_TRACK = false;

           printf("Now into HeadTrack-Modus with X0: %f\n",X0);
        }

    if(( X0 > 5.0 ) && (X0 < 15.0 )) // (90.0 98.0) 100 % = 240 - 230 == 10
        {
           WINDOW_TRACK = false;
           BACK_GROUND_TRACK = false;  
           HEAD_TRACK = false;
           RED_BALL_TRACK = true;
           
           printf("Now Switch into Red-BallTrack-Modus with X0: %f\n",X0); 

           setRGB_NULL();
           simCnt = 1;
             
           ext_SerialServoControl();

           printf("\nNOW END SIM\n");

           // only for Testing
           //mimikryBuuhaPoseRight();

           AUTO_COLORSLIDE_KEYa = true; 
        }
  } 
/**************************************************************************************************/
/*
   NeuralNet FOR BEHAVIOR
   DD. 08.03.2010
   at simBehavior0206E1.cpp
   --------------------------
*/
void neuralNet()
  {
     printf("NeuralNet\n");
     
    inStates = weight0 / 100.0;
    inBehavior = behavior;
    inPing = (max_range_mm - range_mm) * pingFac;

    in_1 = inBehavior;
    in_2 = inPing;
    W_11 = inStates;
    W_12 = (inStates / 4.0) + inStates;
    W_21 = (inStates / 8.0) + inStates;
    W_22 = (inStates / 10.0) + inStates;

    // was passiert mit W_31 & W_32
    printf("W_31: %f, W_32: %f\n",W_31,W_32); 

    Hid_in_1 = (in_1 * W_12) + (in_2 * W_22);
    printf("Hidden Input 1 =  %f\n",Hid_in_1);
    
    Hid_in_2 = (in_2 * W_11) + (in_2 * W_21);
    printf("Hidden Input 2 = %f\n",Hid_in_2);
    
    Hid_out_1 =  1/(1+exp(-1 * Hid_in_1)); 
    printf("Hidden output 1 = %f\n",Hid_out_1);
    
    Hid_out_2 = 1/(1+exp(-1 * Hid_in_2)); 
    printf("Hidden output 2 = %f\n",Hid_out_2);
    
    Out_in_3 = (Hid_out_2 * W_31) + (Hid_out_1 * W_32);
    printf("Output in_3 = %f\n",Out_in_3);
    
    out_final = 1/(1+exp(-1 * Out_in_3)); 
    printf("Final Output = %f\n",out_final);

    nnBehavior = out_final;
    printf("NN_Behavior: %f\n",nnBehavior);
  
    printf("finished\n"); 
    printf("\n");
  } 

/**************************************************************************************************/
/*
   STATE-MACHINE FOR BEHAVIOR
   DD. 07.03.2010
   at simBehavior0206E1.cpp
   --------------------------

   behavior-Values:
   weight0 = 10.0;     
   X0      = 240.0;  // = StartWert1 Y-dir
   Xf0     = 10.0;   // EndPosY      Y
   ii      = x-dir
*/
void stateMachine()
  {
     // from main into while
     // new SimBehavior0206E1.cpp
     if( simCnt == 0 ) 
        {
           // here better behavior 
           if( WINDOW_TRACK == true )
              {
                 weight0 = 10.0;
              }
           if( BACK_GROUND_TRACK == true )
              {
                 weight0 = 7.50;
              }
           if( HEAD_TRACK == true)
              {
                 weight0 = 5.0;
              }
           if( RED_BALL_TRACK == true) 
              {
                 weight0 = 15.0;  
                 
                 if(( X0 > 9.5 ) && (X0 < 10.5))
                    {
                        // original 
                        // X0  = 240.0;  // = StartWert1 Y-dir
                        // Xf0 = 10.0;   // EndPosY      Y
                         
                        X0      =  10.0; // max start
                        Xf0     = 120.0; // down to
                        weight0 =  20.0;
                    }
              }    
           printf("StateMachine: SimBehavior\n"); 
        }

     if( AUTO_COLORSLIDE_KEYa == true )    
        {
           if(( X0 > 118.0 ) && (X0 < 122.0 )) // 120
              {
                 X0      = 120.0;
                 Xf0     = 180.0;
                 weight0 =  15.0;

                 printf("StateMachine: AUTO_COLORSLIDE (TRUE):\n"); 
              }                           
         
           if(RED_BALL_TRACK == true)
              {
                 if(( X0 < 182.0 ) && (X0 > 178.0 )) // == 180
                    {
                       X0 = 180.0;
                       Xf0 = 10.0;
                       weight0 = 5.0;

                       printf("StateMachine RED_BALL_TRACK (TRUE): X0:\n"); 
                    } 
              }
           
           if(RED_BALL_TRACK == false)
              {
                 Xf0     = 75.0;
                 weight0 =  7.5;
                  
                 printf("StateMachine RED_BALL_TRACK (FALSE):\n"); 
              }  

        } // end // automatical Switch into AutoColorSlider no key <a>  
     
     // ex ausserhalb NOK for behavior raus
     
     printf("StateMachine with: X0: %f, Xf0: %f, weight0: %f\n",X0,Xf0,weight0); 

  } 
/**************************************************************************************************/
void Behavior()
  {
     printf("Behavior\n");
     
     /*
     formula:
     - grundlagen: graphic: ii = steps in X-Richtung
       x  = steps in Y-Richtung wobei in der 1.Version x immer kleiner wird
       startpunkt: x = 0; y = 90; 

     - mit formula:
       - X = ((X * (weight-1)+Xf) / weight);
       - sehr schnelles ansteigen eigentlich perfect
       - wobei der wert: 10.0 == Xf => endwert ist 
     */

     // neubau 07.03.
     // regelung von behavior and winglets  
     stateMachine();  

     // Behavior
     X0 = ((X0 * (weight0-1)+Xf0) / weight0);

     printf("\nBEHAVIOR (1): X0: %f, XF0: %f, Weight0: %f\n",X0,Xf0,weight0);
   
     intX0 = (int)X0;
   
     // Behavior Calculations
     // ( positiv ) nach oben
     if(Xf0 < normal)
        {
           behavior = (normal - Xf0) * factor; // == + n.nnn;
        }
     if(Xf0 == normal)
        {
           behavior = 0.0;
        } 
     if(Xf0 > normal)  
        {
           behavior = (Xf0 - normal) * factor * (-1.0); // == - n.nnn; 
        }

     printf("BEHAVIOR (2): %f\n",behavior);  

     // new 08.03. neuralNet
     neuralNet();

     // koppelung von Behavior to WingletsTurn
     /*  
       wingBase   = 51300;
       wingCenter = 1300
       wingUp     = 1950    
       wingDown   = 1300
       stepwidth: =  650
       wingFactor = 650 / 100 = 6.5;
       wingStep   = (Behavior * wingFactor) * 100.0
       wingServo:
       wingServoUp   = wingBase + wingStep;     Old: wingBase - wingStep;
       wingServoDown = wingServoUp - wingStep;  Old: wingServoUp + wingStep;
       
       double wingBase = 51300.0;
       double wingFactor = 6.5;
       double wingStep;
       double wingServoUp;
       double wingServoDown;
       int wingServoCenter = 51300;
     */
     wingStep    = (behavior * wingFactor) * 100.0;
     wingServoUp = wingBase + wingStep;             // Old: wingBase - wingStep;
  
     int wingServo;
     wingServo = (int)wingServoUp + 1.0; 

     // new StandAllone Behavior
     // um immer Behavior anzuspringen
     // um unnoetige ServoTracks zu vermeiden
     if(wingServo > 51301)
        {  
           antw = wingServo;
           printf("WingletServoAntw: %d\n",antw);
           // uebergabe an ServoTracking with
           
           ext_servoTrackControl();
        }
     // x-counter
     ii++;   
/*
     // EIGENTUEMLICH SOLLTE EIGENTLICH WEITER OBEN SEIN          

     // Behavior
     X0 = ((X0 * (weight0-1)+Xf0) / weight0);
*/   
     intX0 = (int)X0;
    
     cvCircle( frame2, cvPoint( ii, intX0 ), 4,  cvScalar(0x00,0xff,0xff), -1, 8 );
 
     if(ii == 800)
        {
           ii = 0;
        }

  }

/**************************************************************************************************/
void simUp()
  {
     printf("SimUp\n");
      
     // normal Stage old
     // Behavior();
       
     // new
     simStateMachine();  

      // normal Stage new 07.03.10
     Behavior();
   
  }
/**************************************************************************************************/

void PAINT_RED (IplImage *frame, Display *dpy) 
  {
     printf("\n\nRED-PAINT\n\n");
  
     int xmin, xmax, ymin, ymax;
     
     int top = HEIGHT, bottom = -1, left = WIDTH, right = -1;
     
     if(SEARCHX == -1 || SEARCHY == -1) 
        {
           xmin = 0;
           ymin = 0;
           xmax = WIDTH;
           ymax = HEIGHT;
        } 
      else 
        {
           xmin = MAX (0, SEARCHX - SEARCHRANGE);
           xmax = MIN (WIDTH, SEARCHX + SEARCHRANGE);
           ymin = MAX (0, SEARCHY - SEARCHRANGE);
           ymax = MIN (HEIGHT, SEARCHY + SEARCHRANGE);
        }

     RgbImage image (frame);
      
     int redxt = 0, redyt = 0;
     int count = 0;

     for(int i = ymin; i < ymax; i++) 
        {
           for(int j = xmin; j < xmax; j++) 
              {
                 int r = image[i][j].r;
                 int g = image[i][j].g;
                 int b = image[i][j].b;
                 
                 // if(g < 0x20 && b < 0x20 && r > 0x80) 
                 // old ev. wrong:  -> if(g < rc && b < gc && r > bc)

                 // einbau von cvAutoSlide0100
                 if(RED_BALL_TRACK == true)
                    {
                       rc = 102;
                       gc = 83;
                       bc = 132;  
                    }  
                 if(HEAD_TRACK == true)
                    {
                       rc = 88;
                       gc = 90;
                       bc = 161;
                    }
                 if(BACK_GROUND_TRACK == true)
                    {
                       rc = 107;
                       gc = 167;
                       bc = 199;
                    }
                  if(WINDOW_TRACK == true)
                    {
                       rc = 214;
                       gc = 248;
                       bc = 248;
                    }
                             
                 if(g < gc && b < bc && r > rc)
                    {
                       image[i][j].r=0xFF;
                       image[i][j].g=0x00;
                       image[i][j].b=0x00;
  
                       redyt += i;
                       redxt += j;
                       count++;

                       top = MIN (top, i);
                       bottom = MAX (bottom, i);
                       left = MIN (left, j);
                       right = MAX (right, j);

                    }
              }
        }

     if(count) 
        {
           SEARCHX = redxt / count;
           SEARCHY = redyt / count;
           
           float redx = (float) redxt / count / WIDTH;
           float redy = (float) redyt / count / HEIGHT;
            
           int screenx = (int)(redx * 1480.0 - 100);
           int screeny = (int)(redy * 1000.0 - 100);

           // XTestFakeMotionEvent (dpy, DefaultScreen (dpy), screenx, screeny, 0);
           // boundingbox = cvRect (top, bottom, left, right);
           TOPLEFT = cvPoint (left, top);
           BOTTOMRIGHT = cvPoint (right, bottom);

           // here graphical center box.x, box.y of the redBall
           // a blue rectangle (left,top == center) 
           //   CvRect rgbBox;
            
           rgbBox.x = (int)(left+((left-right)/2)*(-1));
           rgbBox.y = (int)(top+((top-bottom)/2)*(-1));
                                                                                    // yellow
           cvRectangle(frame,cvPoint(rgbBox.x-20,rgbBox.y-20),cvPoint (rgbBox.x+20,rgbBox.y+20),cvScalar(0x00,0xff,0xff), 8, 1);

           // now draw a X-Line to the center of the images:
           cvLine(frame,cvPoint(rgbBox.x,rgbBox.y),cvPoint(rgbBox.x,rgbCAMY),cvScalar(0x00,0xff,0xff),4,8);  
           // now draw a Y-Lineine to the center of the images:
           cvLine(frame,cvPoint(rgbBox.x,rgbCAMY),cvPoint(rgbCAMX,rgbCAMY),cvScalar(0x00,0x00ff,0xff),6,8);  

           // new
           rgbTrackCalc();
          
           int thish = bottom - top;
           int thisw = right - left; 
            
           if(SHAPECHANGE && abs(LASTH - thish) < LASTH * 1 - CHANGEFACTOR) 
              {
                 if(SHAPECHANGE == CHANGE_GROWING)
                    STATE = STATE_UP;
                 else
                    STATE = STATE_DOWN;
                 
              }
           
           if(thish < LASTH * CHANGEFACTOR) SHAPECHANGE = CHANGE_SHRINKING;
           else if (thish * CHANGEFACTOR > LASTH) SHAPECHANGE = CHANGE_GROWING;
           else SHAPECHANGE = CHANGE_NONE;

           LASTH = thish;
           LASTW = thisw;
           
           XFlush (dpy);
        } 
     else 
        {
           SEARCHX = -1;
           SEARCHY = -1;
        }
  }
/**************************************************************************************************/
void ext_simBehavior()
  {
     printf("SIM_BEHAVIOR\n");

     rgbCENTERX = 320;
     rgbCENTERY = 240;

     cvRectangle( frame1, cvPoint(rgbCENTERX-20,rgbCENTERY-20), cvPoint(rgbCENTERX+20,rgbCENTERY+20),  cvScalar(255,255,0), 8, -1 );  
                           
     // new
     simUp(); 
   
     PAINT_RED(frame1, dpy);
     
     // better Sight no filled Rect - yellow       
     cvRectangle(temp1, TOPLEFT, BOTTOMRIGHT, cvScalar(0x00,0xff,0xff), 8, 1);
  }  

/*************************************************************************************************/
