#!/bin/sh
#
#  EXPERIMENTAL
#  compileScript_87.sh for The NomadHeadSystem  Version 0.207 with 2 WebCams & Winglets
#                                               and SoundEngine with FESTIVAL      
#  name compileScript_87.sh  
#  dd. 11.03.2010
#  script compile & run ok  

#
echo "Remove all O-files"
rm *.o
echo "Remove nomadHeadSystem0207"
rm nomadHeadSystem0207
echo "Compilation of nomadHeadSystem0207"
g++ -I/usr/local/include/opencv -c nomadHeadSystem0207.cpp  
g++ -c servoTracking0207.cpp  
g++ -I/usr/local/include/opencv -c redBallTracking0207.cpp  # ex: colorTracking0205.cpp  
g++ -c headSensor0207.cpp 
g++ -I/usr/local/include/opencv -c bodyTracking0207.cpp  
g++ -I/usr/local/include/opencv -c simBehavior0207.cpp  
g++ -c audioWriter0207.cpp
g++ -I/usr/local/include/opencv -L /usr/local/lib -lcxcore -lcv -lhighgui -lcvaux -lml nomadHeadSystem0207.o servoTracking0207.o redBallTracking0207.o headSensor0207.o bodyTracking0207.o simBehavior0207.o audioWriter0207.o -o nomadHeadSystem0207 -lm 
echo "Compile NomadHeadSystem0207 is Done"
exit 0


